if not Watcher then return end

if select(2, UnitClass('player')) ~= "HUNTER" then return end

local LBF = LibStub("LibButtonFacade", true)
local L = LibStub("AceLocale-3.0"):GetLocale("Watcher")
local media = LibStub:GetLibrary("LibSharedMedia-3.0");
local C = Watcher.constants

C["Serpent Sting"], _, C["Serpent Sting Icon"] = GetSpellInfo(49001)
C["Explosive Shot"], _, C["Explosive Shot Icon"] = GetSpellInfo(60053)
C["Aimed Shot"], _, C["Aimed Shot Icon"] = GetSpellInfo(49050)
C["Lock and Load"], _, C["Lock and Load Icon"] = GetSpellInfo(56453)
C["Beast Lore"], _, C["Beast Lore Icon"] = GetSpellInfo(1462)
C["Black Arrow"], _, C["Black Arrow Icon"] = GetSpellInfo(63672)
C["Kill Shot"], _, C["Kill Shot Icon"] = GetSpellInfo(61006)
C["Steady Shot"], _, C["Steady Shot Icon"] = GetSpellInfo(49052)
C["Arcane Shot"], _, C["Arcane Shot Icon"] = GetSpellInfo(49045)
C["Chimera Shot"], _, C["Chimera Shot Icon"] = GetSpellInfo(53209)
C["Multi-Shot"], _, C["Multi-Shot Icon"] = GetSpellInfo(49048)
C["Aspect of the Dragonhawk"], _, C["Aspect of the Dragonhawk Icon"] = GetSpellInfo(61847)
C["Aspect of the Viper"], _, C["Aspect of the Viper Icon"] = GetSpellInfo(34074)
C["Hunter's Mark"], _, C["Hunter's Mark Icon"] = GetSpellInfo(53338)
C["Rapid Fire"], _, C["Rapid Fire Icon"] = GetSpellInfo(3045)
C["Bestial Wrath"], _, C["Bestial Wrath Icon"] = GetSpellInfo(19574)
C["Blood Fury"], _, C["Blood Fury Icon"] = GetSpellInfo(20572)
C["Readiness"], _, C["Readiness Icon"] = GetSpellInfo(23989)
C["Kill Command"], _, C["Kill Command Icon"] = GetSpellInfo(34026)

local esDotTime = 0

function Watcher:UNIT_SPELLCAST_SUCCEEDED()
	if arg1 == "player" then
		if arg2 == C["Explosive Shot"] then
			esDotTime = 2 + GetTime()
		end
	end
end
	
function Watcher:GetSerpentStingInfo()
	local index = 1
	while UnitDebuff("target", index) do
		local name, _, _, count, _, _, debuffExpires, caster = UnitDebuff("target", index)
		if name == C["Serpent Sting"] and caster == "player" then 
			return debuffExpires - GetTime(), 0
		end
		index = index + 1
	end
	return 0, 0
end

function Watcher:GetHMInfo()
	local index = 1
	while UnitDebuff("target", index) do
		local name, _, _, count, _, _, debuffExpires = UnitDebuff("target", index)
		if name == C["Hunter's Mark"] then 
			return debuffExpires - GetTime(), count
		end
		index = index + 1
	end
	return 0, 0
end

function Watcher:GetESTickInfo()
	local index = 1
	while UnitDebuff("target", index) do
		local name, _, _, count, _, _, debuffExpires, caster = UnitDebuff("target", index)
			if name == C["Explosive Shot"] and caster == "player" then 
				return debuffExpires - GetTime(), count
			end
			
		index = index + 1
	end
	return 0, 0
end

function Watcher:GetLockandLoadInfo()
	local index = 1
	while UnitBuff("PLAYER", index) do
		local name, _, _, count, _, _, lnlTime = UnitBuff("PLAYER", index)
		if name == C["Lock and Load"] then
			return count, lnlTime
		end
		index = index + 1
	end
	return 0, 0 
end

Watcher.priorityTable.name["es"] = C["Explosive Shot"]
Watcher.priorityTable.icon["es"] = C["Explosive Shot Icon"]
Watcher.priorityTable.check["es"] = 
	function (FrameName, optionnum) 
			Watcher:UpdateSpell(FrameName, optionnum, false, 0, true, esDotTime, 1, C["Explosive Shot"], 0, 0, 0) 
	end 	

Watcher.priorityTable.name["hm"] = C["Hunter's Mark"]
Watcher.priorityTable.icon["hm"] = C["Hunter's Mark Icon"]
Watcher.priorityTable.check["hm"] =  
	function (FrameName, optionnum) 
		Watcher:UpdateSpell(FrameName, optionnum, true, Watcher:GetHMInfo(), false, 0, 1, C["Hunter's Mark"], 0, 0, 0)
		end
		
Watcher.priorityTable.name["gcd"] = C["Beast Lore"]
Watcher.priorityTable.icon["gcd"] = C["Beast Lore Icon"]
Watcher.priorityTable.check["gcd"] =  
	function (FrameName, optionnum) 	
		local start, duration = GetSpellCooldown(C["Beast Lore"])
		if duration > 0 then
			FrameName:SetAlpha(1)
			local timeleft = start + duration - GetTime()
			Watcher:MoveIcon(FrameName, timeleft)
			FrameName.Text:SetText(Watcher:DurationString(timeleft))
			return
		end
		if start == 0 then
			FrameName.Text:Hide()
			FrameName:SetAlpha(0)
		else
			FrameName.Text:Show()
		end
	end 
	
Watcher.priorityTable.name["rf"] = C["Rapid Fire"]
Watcher.priorityTable.icon["rf"] = C["Rapid Fire Icon"]
Watcher.priorityTable.check["rf"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Rapid Fire"], 0, 0, 0)
		end 
	
Watcher.priorityTable.name["bf"] = C["Blood Fury"]
Watcher.priorityTable.icon["bf"] = C["Blood Fury Icon"]
Watcher.priorityTable.check["bf"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Blood Fury"], 0, 0, 0)
		end
	
Watcher.priorityTable.name["bw"] = C["Bestial Wrath"]
Watcher.priorityTable.icon["bw"] = C["Bestial Wrath Icon"]
Watcher.priorityTable.check["bw"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Bestial Wrath"], 0, 0, 0)
		end

Watcher.priorityTable.name["ss"] = C["Serpent Sting"]
Watcher.priorityTable.icon["ss"] = C["Serpent Sting Icon"]
Watcher.priorityTable.check["ss"] =  
	function (FrameName, optionnum) 
		Watcher:UpdateSpell(FrameName, optionnum, true, Watcher:GetSerpentStingInfo(), false, 0, 1, C["Serpent Sting"], 0, 0, 0)
		end
	
Watcher.priorityTable.name["aimedshot"] = C["Aimed Shot"]
Watcher.priorityTable.icon["aimedshot"] = C["Aimed Shot Icon"]
Watcher.priorityTable.check["aimedshot"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Aimed Shot"], 0, 0, 0)	
		end
	
Watcher.priorityTable.name["cs"] = C["Chimera Shot"]
Watcher.priorityTable.icon["cs"] = C["Chimera Shot Icon"]
Watcher.priorityTable.check["cs"] =  
	function (FrameName, optionnum) 	
	Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Chimera Shot"], 0, 0, 0)		
	end
	
Watcher.priorityTable.name["arcaneshot"] = C["Arcane Shot"]
Watcher.priorityTable.icon["arcaneshot"] = C["Arcane Shot Icon"]
Watcher.priorityTable.check["arcaneshot"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Arcane Shot"], 0, 0, 0)	
		end
	
Watcher.priorityTable.name["multishot"] = C["Multi-Shot"]
Watcher.priorityTable.icon["multishot"] = C["Multi-Shot Icon"]
Watcher.priorityTable.check["multishot"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Multi-Shot"], 0, 0, 0)		
		end
	
Watcher.priorityTable.name["steadyshot"] = C["Steady Shot"]
Watcher.priorityTable.icon["steadyshot"] = C["Steady Shot Icon"]
Watcher.priorityTable.check["steadyshot"] =  
	function (FrameName, optionnum) 	
	Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Steady Shot"], 0, 0, 0)
		end
	
Watcher.priorityTable.name["killshot"] = C["Kill Shot"]
Watcher.priorityTable.icon["killshot"] = C["Kill Shot Icon"]
Watcher.priorityTable.check["killshot"] =  
	function (FrameName, optionnum)
	Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 0.2, C["Kill Shot"], 0, 0, 0)	
	end
	
Watcher.priorityTable.name["ba"] = C["Black Arrow"]
Watcher.priorityTable.icon["ba"] = C["Black Arrow Icon"]
Watcher.priorityTable.check["ba"] =  
	function (FrameName, optionnum) 	
	Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Black Arrow"], 0, 0, 0)	
	end	
	
Watcher.priorityTable.name["kc"] = C["Kill Command"]
Watcher.priorityTable.icon["kc"] = C["Kill Command Icon"]
Watcher.priorityTable.check["kc"] =  
	function (FrameName, optionnum) 	
	Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Kill Command"], 0, 0, 0)	
	end	
		
Watcher.priorityTable.name["ready"] = C["Readiness"]
Watcher.priorityTable.icon["ready"] = C["Readiness Icon"]
Watcher.priorityTable.check["ready"] =  
	function (FrameName, optionnum) 	
	Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Readiness"], 0, 0, 0)	
	end	